Imports System
Imports System.Collections.Generic
Imports System.Text
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Windows.Forms
Imports System.Xml.Serialization

Namespace WIL.GDI

#Region "萔"
    ''' <summary>
    ''' GDI}`ҏW[h
    ''' </summary>
    Public Enum FigureHandlingMode
        ''' <summary>
        ''' ړƃTCYύX
        ''' </summary>
        Normal
        ''' <summary>
        ''' ]
        ''' </summary>
        Rotate
    End Enum
#End Region

#Region "\"
    ''' <summary>
    ''' L[{[h\
    ''' </summary>
    Public Structure KeyboardInfo
        ''' <summary>
        ''' 
        ''' </summary>
        Public IsDown As Boolean
        ''' <summary>
        ''' ĂL[
        ''' </summary>
        Public Alt As Boolean
        ''' <summary>
        ''' ĂL[
        ''' </summary>
        Public Control As Boolean
        ''' <summary>
        ''' ĂL[
        ''' </summary>
        Public Shift As Boolean
        ''' <summary>
        ''' ĂL[
        ''' </summary>
        Public KeyCode As Keys
        ''' <summary>
        ''' ĂL[
        ''' </summary>
        Public KeyData As Keys
        ''' <summary>
        ''' ĂL[
        ''' </summary>
        Public KeyValue As Integer
    End Structure

    ''' <summary>
    ''' }EX{^̋`̈̏
    ''' </summary>
    Public Structure MouseInfo
        ''' <summary>
        ''' Obv
        ''' </summary>
        Public bGrip As Boolean
        ''' <summary>
        ''' Obvʒu
        ''' </summary>
        Public iGripPosition As Integer
        ''' <summary>
        ''' }EX|C^ʒu
        ''' </summary>
        Public mouse As FVIL.Data.CFviPoint
        ''' <summary>
        ''' Iꂽ}`
        ''' </summary>
        Public figure As FVIL.GDI.CFviGdiFigure
        ''' <summary>
        ''' {^̐}`ʒu
        ''' </summary>
        Public position As FVIL.Data.CFviPoint
        ''' <summary>
        ''' {^̐}`̋@
        ''' </summary>
        Public axis As FVIL.Data.CFviPoint
        ''' <summary>
        ''' {^̐}`̉]p
        ''' </summary>
        Public angle As FVIL.Data.CFviAngle
        ''' <summary>
        ''' {^̐}`̊Oڋ`
        ''' </summary>
        Public clip As FVIL.Data.CFviRectangle
    End Structure
#End Region

#Region "C^[tF[X"
    ''' <summary>
    ''' }EXő삷GDI}`̃C^[tF[X
    ''' </summary>
    Public Interface IFigureHandling
        ''' <summary>
        ''' }EXJ[\̌`ύX۔
        ''' </summary>
        ''' <param name="sender">}EXCxgRg[</param>
        ''' <param name="e">}EXCxg</param>
        ''' <param name="iGripPosition">}EXŒ͂܂ꂽʒu</param>
        Function ChangeCursor(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs, ByVal iGripPosition As Integer)

        ''' <summary>
        ''' }`̕ҏW
        ''' </summary>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        ''' }`̕ҏWsꂽꍇ true Ԃ܂B
        ''' sȂꍇ false Ԃ܂B
        ''' </returns>
        Function ModifyFigure(ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
    End Interface
#End Region

    ''' <summary>
    ''' GDI}`}EXő삷I[oC
    ''' </summary>
    ''' <remarks>
    '''   }`̈ړTCYύX}EXő삷邽߂̃I[oCłB
    ''' </remarks>
    Public Class FigureOverlay : Inherits FVIL.GDI.CFviOverlay

        ''' <summary>
        ''' RXgN^p֐
        ''' </summary>
        Public Sub _Constructor()
            'L[{[h̏
            m_KeyboardInfo.IsDown = False
            m_KeyboardInfo.Alt = False
            m_KeyboardInfo.Control = False
            m_KeyboardInfo.Shift = False
            m_KeyboardInfo.KeyCode = Keys.None
            m_KeyboardInfo.KeyData = Keys.None
            m_KeyboardInfo.KeyValue = 0
            '}EX{^̏
            m_MouseInfo.bGrip = False
            m_MouseInfo.iGripPosition = 0
            m_MouseInfo.figure = Nothing

        End Sub

        ''' <summary>
        ''' RXgN^
        ''' </summary>
        Public Sub FigureOverlay()
            _Constructor()
        End Sub

        ''' <summary>
        ''' RXgN^
        ''' </summary>
        ''' <param name="bMove">}EXɂ}`̈ړ̋</param>
        ''' <param name="bModify">}EXɂ}`̕ҏW̋</param>
        ''' <param name="bRoate">}EXɂ}`̉]̋</param>
        Public Sub FigureOverlay(ByVal bMove As Integer, ByVal bModify As Integer, ByVal bRoate As Integer)
            _Constructor()
            EnableMove = bMove
            EnableModify = bModify
            EnableRotate = bRoate
        End Sub

        Public m_KeyboardInfo As KeyboardInfo = New KeyboardInfo()
        ''' <summary>
        ''' L[{[h̏
        ''' </summary>
        <XmlIgnore()> _
        <Browsable(False)> _
        <Category("t")> _
        <Description("L[{[h̏ێĂ܂B")> _
        Public Property KeyboardInfo() As KeyboardInfo
            Get
                Return m_KeyboardInfo
            End Get
            Set(ByVal value As KeyboardInfo)
                m_KeyboardInfo = value
            End Set
        End Property

        Public m_MouseInfo As MouseInfo = New MouseInfo()
        ''' <summary>
        ''' }EX{^̏
        ''' </summary>
        <XmlIgnore()> _
        <Browsable(False)> _
        <Category("t")> _
        <Description("}EX{^̏ێĂ܂B")> _
        Public Property MouseInfo() As MouseInfo
            Get
                Return m_MouseInfo
            End Get
            Set(ByVal value As MouseInfo)
                m_MouseInfo = value
            End Set
        End Property

        Public m_HandlingMode As FigureHandlingMode = FigureHandlingMode.Normal
        ''' <summary>
        ''' }`ҏW[h
        ''' </summary>
        <XmlIgnore()> _
        <Category("[h")> _
        <Description("}`̑샂[hwtOłB")> _
        Public Property HandlingMode() As FigureHandlingMode
            Get
                Return m_HandlingMode
            End Get
            Set(ByVal value As FigureHandlingMode)
                m_HandlingMode = value
            End Set
        End Property

        Public m_EnableMove As Boolean = True
        ''' <summary>
        ''' }`ҏW[h (ړ)
        ''' </summary>
        <XmlIgnore()> _
        <Category("[h")> _
        <Description("}EXɂ}`̈ړtOłB")> _
        Public Property EnableMove() As Boolean
            Get
                Return m_EnableMove
            End Get
            Set(ByVal value As Boolean)
                m_EnableMove = value
            End Set
        End Property

        Public m_EnableModify As Boolean = True
        ''' <summary>
        ''' }`ҏW[h (ҏW)
        ''' </summary>
        <XmlIgnore()> _
        <Category("[h")> _
        <Description("}EXɂ}`̕ҏWtOłB")> _
        Public Property EnableModify() As Boolean
            Get
                Return m_EnableModify
            End Get
            Set(ByVal value As Boolean)
                m_EnableModify = value
            End Set
        End Property

        Public m_EnableRotate As Boolean = True
        ''' <summary>
        ''' }`ҏW[h (])
        ''' </summary>
        <XmlIgnore()> _
        <Category("[h")> _
        <Description("}EXɂ}`̉]tOłB")> _
        Public Property EnableRotate() As Boolean
            Get
                Return m_EnableRotate
            End Get
            Set(ByVal value As Boolean)
                m_EnableRotate = value
            End Set
        End Property

        ''' <summary>
        ''' }`̎擾 (I𑮐w)
        ''' </summary>
        ''' <param name="selection">I𑮐</param>
        ''' <returns>
        '''   w肳ꂽI𑮐ƈv}`Ԃ܂B
        '''   Ȃ Nothing Ԃ܂B
        ''' </returns>
        Public Function GetSelectedFigure(ByVal selection As Boolean) As FVIL.GDI.CFviGdiFigure
            'z̖(y̑O)珈.
            For i As Integer = Figures.Count - 1 To i >= 0 Step -1
                Dim figure As FVIL.GDI.CFviGdiFigure = Figures(i)
                If (figure.Select = selection) Then
                    Return figure
                End If
            Next
            Return Nothing
        End Function

        ''' <summary>
        ''' }`̎擾 (ʒuw)
        ''' </summary>
        ''' <param name="x">wʒuX (NCAgW)</param>
        ''' <param name="y">wʒuY (NCAgW)</param>
        ''' <returns>
        '''   wʒuɂ}`Ԃ܂B
        '''   Ȃ Nothing Ԃ܂B
        ''' </returns>
        Public Function GetFigure(ByVal x As Integer, ByVal y As Integer) As FVIL.GDI.CFviGdiFigure
            Return GetFigure(New Point(x, y))
        End Function

        ''' <summary>
        ''' }`̎擾 (ʒuw)
        ''' </summary>
        ''' <param name="location">wʒu (NCAgW)</param>
        ''' <returns>
        '''   wʒuɂ}`Ԃ܂B
        '''   Ȃ Nothing Ԃ܂B
        ''' </returns>
        Public Function GetFigure(ByVal location As Point) As FVIL.GDI.CFviGdiFigure
            'ViewNCAg̈ł̍W.
            'Scaling = true ̎́A摜Wɕϊ.
            Dim position As FVIL.Data.CFviPoint = IIf(Scaling, DPtoIP(location, ScalingMode), New FVIL.Data.CFviPoint(location))

            'z̖(y̑O)珈.
            For i As Integer = Figures.Count - 1 To i >= 0 Step -1
                Dim figure As FVIL.GDI.CFviGdiFigure = Figures(i)
                Dim margin As Double = IIf(Scaling, 4 / Magnification, 4)
                Dim iGripPosition As Integer = figure.CheckFocusMarkPosition(position, margin)
                If (iGripPosition <> 0) Then
                    Return figure
                End If
            Next
            Return Nothing
        End Function

        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="src"></param>
        ''' <returns>
        '''   w肳ꂽNX^̃N[𐶐ĕԂ܂B
        '''   wf̃NX^x Clone ́Ał Shallow Copy ̂ŔzvfPP Deep Copy ܂B
        '''   vfwf̃NX^xłȂ Clone \bhŃN[𐶐܂B
        '''   vfwf̃NX^x̏ꍇ́AX DeepCopy s܂B
        ''' </returns>
        Public Function DeepCopy(ByVal src As FVIL.GDI.CFviGdiCluster) As FVIL.GDI.CFviGdiCluster
            Dim clone As FVIL.GDI.CFviGdiCluster = DirectCast(src.Clone(), FVIL.GDI.CFviGdiCluster)
            For i As Integer = 0 To src.Figures.Count - 1
                Dim item As FVIL.GDI.CFviGdiFigure = src.Figures(i)
                'wf̃NX^x̔ typeof ōs܂.
                'is L[[h CFviGdiCluster ̔hNXΏۂɂȂ̂ŒӂKvł.
                If (TypeOf (item) Is FVIL.GDI.CFviGdiCluster) Then
                    clone.Figures(i) = DeepCopy(DirectCast(item, FVIL.GDI.CFviGdiCluster))
                Else
                    clone.Figures(i) = DirectCast(item.Clone(), FVIL.GDI.CFviGdiFigure)
                End If
            Next
            Return clone
        End Function

        ''' <summary>
        ''' g̐̕ (pK{)
        ''' </summary>
        ''' <returns>
        '''   g̃CX^X̕Ԃ܂B
        ''' </returns>
        Public Overrides Function Clone() As System.Object
            Dim copy As FigureOverlay = New FigureOverlay()
            copy.CopyFrom(Me)
            Return copy
        End Function

        ''' <summary>
        ''' CX^X̕ (pK{)
        ''' </summary>
        ''' <param name="src"></param>
        ''' <returns>
        '''   ̎g̃CX^XԂ܂B
        ''' </returns>
        ''' <remarks>
        '''   {NX CopyFrom ́AFigures z̐}`̃CX^X Shallow Rs[܂B
        '''   ̏ꍇ́Aƕ̃I[oCœ̃CX^XۗL邱ƂɂȂ܂B
        '''    Deep Rs[(CX^X̃Rs[łȂAe𕡐邱)ꍇ́A
        '''   L̂悤 CopyFigures I[o[ChĂB
        '''   {NX CopyFrom ́ACX^X Shallow Rs[sO CopyFigures Ăяo܂B
        ''' </remarks>
        Public Overrides Function CopyFrom(ByVal src As System.Object) As System.Object
            MyBase.CopyFrom(src)
            Dim copy As FVIL.GDI.CFviOverlay = New FVIL.GDI.CFviOverlay()
            Return Me
        End Function

#If False Then    'TODO: Ǝ̐}`sꍇ́ÃfBNeBuLɂĂ.
        ''' <summary>
        ''' Ǝ̐}`
        ''' </summary>
        ''' <param name="src"></param>
        Protected Overrides Sub CopyFigures(ByVal src As FVIL.GDI.CFviOverlay)
            Dim _src As FigureOverlay = src
            'TODO: ŕsĂ.
        End Sub
#End If

        ''' <summary>
        ''' nbVR[h̐ (pK{)
        ''' </summary>
        ''' <returns>
        ''' </returns>
        Public Overrides Function GetHashCode() As Integer
            Return MyBase.GetHashCode()
        End Function

        ''' <summary>
        ''' CX^X̓er (pK{)
        ''' </summary>
        ''' <param name="src">rΏ</param>
        ''' <returns>
        '''   vꍇ true AvȂꍇ false Ԃ܂B
        ''' </returns>
        Public Overrides Function Equals(ByVal src As Object) As Boolean
            If (ReferenceEquals(src, DBNull.Value)) Then
                Return False
            End If

            Try
                Dim _src As FigureOverlay = src
                'TODO: Ǝ̔rꍇ́AōsĂ.
                Return MyBase.Equals(src)
            Catch ex As Exception
                Return False
            End Try
        End Function

        ''' <summary>
        ''' rIy[^ ()
        ''' </summary>
        ''' <param name="ope1">Ӓl</param>
        ''' <param name="ope2">EӒl</param>
        ''' <returns>
        '''   vꍇ true AvȂꍇ false Ԃ܂B
        ''' </returns>
        Public Shared Operator =(ByVal ope1 As FigureOverlay, ByVal ope2 As FigureOverlay) As Boolean
            If (ReferenceEquals(ope1, DBNull.Value)) Then
                Return ReferenceEquals(ope2, DBNull.Value)
            End If
            Return ope1.Equals(ope2)
        End Operator

        ''' <summary>
        ''' rIy[^ (s)
        ''' </summary>
        ''' <param name="ope1">Ӓl</param>
        ''' <param name="ope2">EӒl</param>
        ''' <returns>
        '''   vꍇ true AvȂꍇ false Ԃ܂B
        ''' </returns>
        Public Shared Operator <>(ByVal ope1 As FigureOverlay, ByVal ope2 As FigureOverlay) As Boolean
            Return (Not (ope1 = ope2))
        End Operator

        ''' <summary>
        ''' `揈
        ''' </summary>
        ''' <param name="hdc">`̃foCXReLXg</param>
        ''' <param name="region">`͈</param>
        ''' <returns>
        '''   `悳ꂽ}`̌Ԃ܂B
        ''' </returns>
        Public Overrides Function Play(ByVal hdc As System.IntPtr, ByVal region As System.Drawing.Rectangle) As Integer
            If ((Not Enable) And (Not Active)) Then
                Return 0
            End If

            Dim iCount As Integer = MyBase.Play(hdc, region)
            Return iCount
        End Function

        ''' <summary>
        ''' }EXCxgnh̓o^
        ''' </summary>
        ''' <param name="control"></param>
        Public Overrides Sub AddMouseEventHandler(ByVal control As System.Windows.Forms.Control)
            AddHandler control.KeyDown, AddressOf OnKeyDown
            AddHandler control.KeyUp, AddressOf OnKeyUp
            AddHandler control.PreviewKeyDown, AddressOf OnPreviewKeyDown
            AddHandler control.MouseDown, AddressOf OnMouseDown
            AddHandler control.MouseMove, AddressOf OnMouseMove
            AddHandler control.MouseUp, AddressOf OnMouseUp
            AddHandler control.MouseLeave, AddressOf OnMouseLeave
        End Sub

        ''' <summary>
        ''' }EXCxgnh̉
        ''' </summary>
        ''' <param name="control"></param>
        Public Overrides Sub DelMouseEventHandler(ByVal control As System.Windows.Forms.Control)
            RemoveHandler control.KeyDown, AddressOf OnKeyDown
            RemoveHandler control.KeyUp, AddressOf OnKeyUp
            RemoveHandler control.PreviewKeyDown, AddressOf OnPreviewKeyDown
            RemoveHandler control.MouseDown, AddressOf OnMouseDown
            RemoveHandler control.MouseMove, AddressOf OnMouseMove
            RemoveHandler control.MouseUp, AddressOf OnMouseUp
            RemoveHandler control.MouseLeave, AddressOf OnMouseLeave
        End Sub

#Region "}EXObv۔"
        ''' <summary>
        ''' }EXObv۔
        ''' </summary>
        ''' <param name="sender">}EXCxgRg[</param>
        ''' <param name="e">}EXCxg</param>
        ''' <param name="AllowGrip">ObvXe[^X</param>
        Public Overrides Sub CanMouseGrip(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs, ByRef AllowGrip As Boolean)
            If (Not Active) Then
                Return    'Ȃ.
            End If
            If (Not AllowGrip) Then
                Return    'ObvĂȂ.
            End If

            Try
                If (m_MouseInfo.bGrip = False) Then
                    '}`̑I𑮐ύXꂽtO.
                    Dim bSelectedStatusChanged As Boolean = False

                    Dim position As FVIL.Data.CFviPoint = IIf(Scaling, DPtoIP(e.Location, ScalingMode), New FVIL.Data.CFviPoint(e.Location))
                    'z̖(y̑O)珈.
                    For i As Integer = Figures.Count - 1 To i >= 0 Step -1
                        Dim figure As FVIL.GDI.CFviGdiFigure = Figures(i)
                        If (Not figure.Enable) Then
                            Continue For
                        End If

                        Dim margin As Double = IIf(Scaling, 4 / Magnification, 4)
                        Dim iGripPosition As Integer = figure.CheckFocusMarkPosition(position, margin)
                        If (iGripPosition <> 0) Then
                            'I𑮐̕ύX.
                            If (figure.Select = True) Then
                                If (m_KeyboardInfo.IsDown And (m_KeyboardInfo.Control = False) And (m_KeyboardInfo.Alt = False) And (m_KeyboardInfo.Shift = True)) Then
                                    'SHIFT Ă.
                                    figure.Select = False
                                    bSelectedStatusChanged = True
                                    Exit For
                                End If
                            Else
                                figure.Select = True
                                bSelectedStatusChanged = True
                            End If
                            '(!) p`ɑ΂bIȏu.
                            If (TypeOf (figure) Is FVIL.GDI.CFviGdiPolyline) Then
                                'CFviGdiPolyline  Close ̂Ƃ_Ŕ鏈u.
                                'XbhZ[tł͂Ȃ̂Œ.
                                '{́Ap CheckFocusMarkPosition I[o[Chׂ.
                                Dim _figure As FVIL.GDI.CFviGdiPolyline = DirectCast(figure, FVIL.GDI.CFviGdiPolyline)
                                If (_figure.Close) Then
                                    _figure.Close = False
                                    Dim iGripVetex As Integer = _figure.CheckFocusMarkPosition(position, margin)
                                    _figure.Close = True
                                    '_܂͕ӈȊOŊOڋ`̂Ƃ͈ړ(-1)Ƃ.
                                    iGripPosition = IIf(iGripVetex <> 0, iGripVetex, -1)
                                End If
                            End If

                            'ViewNCAg̈ł̍W.
                            'Scaling = true ̎́A摜Wɕϊ.
                            Dim mouse As FVIL.Data.CFviPoint = IIf(Scaling, DPtoIP(e.Location, ScalingMode), New FVIL.Data.CFviPoint(e.Location))

                            'ObvʒuƐ}`̏Ԃێ.
                            m_MouseInfo.bGrip = True
                            m_MouseInfo.iGripPosition = iGripPosition
                            m_MouseInfo.mouse = mouse
                            m_MouseInfo.figure = figure
                            m_MouseInfo.position = figure.Position
                            m_MouseInfo.axis = figure.Axis
                            m_MouseInfo.angle = figure.Angle
                            m_MouseInfo.clip = figure.GetClipRect()
                            Validate(m_MouseInfo)       'L.
                            Exit For
                        End If
                    Next
                    'I𑮐̐؂ւ.
                    If (m_KeyboardInfo.IsDown And (m_KeyboardInfo.Control = False) And (m_KeyboardInfo.Alt = False) And (m_KeyboardInfo.Shift = True)) Then
                        'SHIFT ĂƂ.
                    Else
                        'SHIFT ĂȂƂ.
                        If (m_MouseInfo.bGrip = False) Then
                            '͂܂Ȃꍇ́ASăZbg.
                            m_MouseInfo.figure = Nothing
                            For i As Integer = Figures.Count - 1 To i >= 0 Step -1
                                Dim figure As FVIL.GDI.CFviGdiFigure = Figures(i)
                                figure.Select = False
                            Next
                        ElseIf (bSelectedStatusChanged) Then
                            'I𑮐ɕωƂ́ArIɃZbg.
                            For i As Integer = Figures.Count - 1 To i >= 0 Step -1
                                Dim figure As FVIL.GDI.CFviGdiFigure = Figures(i)
                                If (ReferenceEquals(figure, m_MouseInfo.figure)) Then
                                    figure.Select = True
                                Else
                                    figure.Select = False
                                End If
                            Next
                        End If
                    End If
                End If

                'ȍ~ÃI[oCł̃ObvȂ.
                If (m_MouseInfo.bGrip = True) Then
                    AllowGrip = False
                End If
            Catch ex As Exception

            End Try
            Return
        End Sub
#End Region

        ''' <summary>
        ''' }EXJ[\̌`ύX۔
        ''' </summary>
        ''' <param name="sender">}EXCxgRg[</param>
        ''' <param name="e">}EXCxg</param>
        ''' <param name="AllowChange">J[\ύXXe[^X</param>
        Public Overrides Sub CanChangeCursor(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs, ByRef AllowChange As Boolean)
            If (Not Active) Then
                Return      'Ȃ.
            End If
            If (Not AllowChange) Then
                Return      'J[\ύXĂȂ.
            End If
            'sender ܂ e ȏꍇ͖.
            If (ReferenceEquals(sender, DBNull.Value)) Then
                Return
            End If
            If (ReferenceEquals(e, DBNull.Value)) Then
                Return
            End If

            Try
                'Ώۂ̐}`.
                Dim iGripPosition As Integer = 0
                Dim figure As FVIL.GDI.CFviGdiFigure = Nothing

                'ViewNCAg̈ł̍W.
                'Scaling = true ̎́A摜Wɕϊ.
                Dim position As FVIL.Data.CFviPoint = IIf(Scaling, DPtoIP(e.Location, ScalingMode), New FVIL.Data.CFviPoint(e.Location))

                'z̖(y̑O)珈.
                For i As Integer = Figures.Count - 1 To i >= 0 Step -1
                    figure = Figures(i)
                    If (m_MouseInfo.bGrip = True) Then
                        If (ReferenceEquals(figure, m_MouseInfo.figure)) Then
                            iGripPosition = m_MouseInfo.iGripPosition
                            Exit For
                        End If
                    ElseIf (figure.Enable) Then
                        Dim margin As Double = IIf(Scaling, 4 / Magnification, 4)
                        Dim status As Integer = figure.CheckFocusMarkPosition(position, margin)
                        If (status <> 0) Then
                            iGripPosition = status
                            Exit For
                        End If
                    End If
                Next

                'J[\`̕ύX.
                '  AllowChange ́ÃI[oC̃J[\ύXƊȂ悤ɂׂ̃tOł.
                '   AllowChange  false ̎́ÃI[oCł̃J[\ύXs܂B
                '  AllowChange  true ̎AJ[\`̕ύXs܂B
                '  J[\ύXAAllowChange  false ɕύX܂B

                'J[\ύX.
                If (iGripPosition <> 0) Then
                    If (TypeOf (figure) Is IFigureHandling) Then
                        DirectCast(figure, IFigureHandling).ChangeCursor(sender, e, iGripPosition)
                    Else
                        '̊ȗׁ̈A\J[\݂̂ɂĂ܂,
                        'ObvʒuɂČ`ύXƎoIɕ₷Ȃ܂.
                        DirectCast(sender, System.Windows.Forms.Control).Cursor = System.Windows.Forms.Cursors.SizeAll
                    End If
                    'ȍ~AύXȂ.
                    AllowChange = False
                End If
            Catch ex As Exception
            End Try
            Return
        End Sub

        ''' <summary>
        ''' L[{[hCxg (L[)
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnKeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
            m_KeyboardInfo.IsDown = True
            m_KeyboardInfo.Alt = e.Alt
            m_KeyboardInfo.Control = e.Control
            m_KeyboardInfo.Shift = e.Shift
            m_KeyboardInfo.KeyCode = e.KeyCode
            m_KeyboardInfo.KeyData = e.KeyData
            m_KeyboardInfo.KeyValue = e.KeyValue
        End Sub

        ''' <summary>
        ''' L[{[hCxg (L[𗣂)
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnKeyUp(ByVal sender As Object, ByVal e As KeyEventArgs)
            m_KeyboardInfo.IsDown = False
        End Sub

        ''' <summary>
        ''' L[{[hCxg (L[)
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnPreviewKeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.PreviewKeyDownEventArgs)
        End Sub

        ''' <summary>
        ''' }EX{^ꂽ̏
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnMouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
        End Sub

        ''' <summary>
        ''' }EX{^ꂽ̏
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnMouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
            m_MouseInfo.bGrip = False
        End Sub

        ''' <summary>
        ''' }EXJ[\ړĂ鎞̏
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnMouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs)
            If (Active = False) Then
                Return
            End If

            If (m_MouseInfo.bGrip) Then
                'ViewNCAg̈ł̍W.
                'Scaling = true ̎́A摜Wɕϊ.
                Dim current As FVIL.Data.CFviPoint = IIf(Scaling, DPtoIP(e.Location, ScalingMode), New FVIL.Data.CFviPoint(e.Location))

                Dim figure As FVIL.GDI.CFviGdiFigure = m_MouseInfo.figure

                '}`̑.
                HandlingFigure(m_MouseInfo.figure, current, m_MouseInfo, m_KeyboardInfo)

                DirectCast(sender, System.Windows.Forms.Control).Refresh()
            End If
        End Sub

        ''' <summary>
        ''' }EXJ[\ꂽ̏
        ''' </summary>
        ''' <param name="sender"></param>
        ''' <param name="e"></param>
        Public Sub OnMouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs)
            m_MouseInfo.bGrip = False
        End Sub

        ''' <summary>
        ''' }EX̏L
        ''' </summary>
        ''' <param name="info">}EX̏</param>
        ''' <returns>
        '''   ύXꍇ true Ԃ܂BȊO false Ԃ܂B
        ''' </returns>
        ''' <remarks>
        '''   }`̍W]ĂꍇɁAOڋ`̃}EXObvʒu]܂B
        '''   Oڋ`ɂĕό`s}`ΏۂłB
        '''   ̃\bh́A}EXObvɈxĂяo悤ɂĂB
        ''' </remarks>
        Public Function Validate(ByRef info As MouseInfo) As Boolean
            If (ReferenceEquals(info.figure, DBNull.Value)) Then
                Return False
            End If
            If (info.iGripPosition = 0) Then
                Return False
            End If

            Dim bReverseH As Boolean = False        '].
            Dim bReverseV As Boolean = False        '].

            'Ώۂ̐}`.
            If (TypeOf (info.figure) Is FVIL.GDI.CFviGdiCircle) Then
                Dim figure As FVIL.GDI.CFviGdiCircle = DirectCast(info.figure, FVIL.GDI.CFviGdiCircle)
                bReverseH = (figure.Radius < 0)
                bReverseV = (figure.Radius < 0)
            ElseIf (TypeOf (info.figure) Is FVIL.GDI.CFviGdiEllipse) Then
                Dim figure As FVIL.GDI.CFviGdiEllipse = DirectCast(info.figure, FVIL.GDI.CFviGdiEllipse)
                bReverseH = (figure.AxisX < 0)
                bReverseV = (figure.AxisX < 0)
            ElseIf (TypeOf (info.figure) Is FVIL.GDI.CFviGdiRectangle) Then
                Dim figure As FVIL.GDI.CFviGdiRectangle = DirectCast(info.figure, FVIL.GDI.CFviGdiRectangle)
                bReverseH = (figure.Width < 0)
                bReverseV = (figure.Height < 0)
            Else
                Return False
            End If

            'Oڋ`̈ʒu.
            Dim rectpos As FVIL.GDI.RectPosition = DirectCast(info.iGripPosition, FVIL.GDI.RectPosition)
            Dim L As Boolean = ((rectpos And FVIL.GDI.RectPosition.Left) = FVIL.GDI.RectPosition.Left)
            Dim R As Boolean = ((rectpos And FVIL.GDI.RectPosition.Right) = FVIL.GDI.RectPosition.Right)
            Dim T As Boolean = ((rectpos And FVIL.GDI.RectPosition.Top) = FVIL.GDI.RectPosition.Top)
            Dim B As Boolean = ((rectpos And FVIL.GDI.RectPosition.Bottom) = FVIL.GDI.RectPosition.Bottom)

            '].
            If (bReverseH) Then
                If (L And (Not R)) Then
                    '݁A ON ̎A OFF ĉE ON .
                    rectpos = rectpos And (Not FVIL.GDI.RectPosition.Left)
                    rectpos = rectpos Or FVIL.GDI.RectPosition.Right
                End If
                If (R And (Not L)) Then
                    '݁AE ON ̎AE OFF č ON .
                    rectpos = rectpos And (Not FVIL.GDI.RectPosition.Right)
                    rectpos = rectpos Or FVIL.GDI.RectPosition.Left
                End If
            End If

            '].
            If (bReverseV) Then
                If (T And (Not B)) Then
                    '݁Aオ ON ̎A OFF ĉ ON .
                    rectpos = rectpos And (Not FVIL.GDI.RectPosition.Top)
                    rectpos = rectpos Or FVIL.GDI.RectPosition.Bottom
                End If
                If (B And (Not T)) Then
                    '݁A ON ̎A OFF ď ON .
                    rectpos = rectpos And (Not FVIL.GDI.RectPosition.Bottom)
                    rectpos = rectpos Or FVIL.GDI.RectPosition.Top
                End If
            End If

            'f.
            info.iGripPosition = rectpos

            Return (bReverseH Or bReverseV)
        End Function

        ''' <summary>
        ''' }`̑ ()
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function HandlingFigure(ByVal figure As FVIL.GDI.CFviGdiFigure, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            Dim mode As FigureHandlingMode = HandlingMode

            '[h̐؂ւ.
            If (key.IsDown And (key.Control = False) And (key.Alt = True) And (key.Shift = False)) Then
                'ALT ĂƂ.
                If (mode = FigureHandlingMode.Normal) Then
                    mode = FigureHandlingMode.Rotate
                ElseIf (mode = FigureHandlingMode.Rotate) Then
                    mode = FigureHandlingMode.Normal
                End If
            End If

            ']̋֎~.
            If ((Not EnableRotate) And mode = FigureHandlingMode.Rotate) Then
                mode = FigureHandlingMode.Normal
            End If

            If (mode = FigureHandlingMode.Rotate) Then
                '}`̉].
                Return RotateFigure(figure, current, info, key)
            Else
                '}`̕ό`܂͈ړ.
                If (Not EnableModify) Then        'ό`̋֎~.
                    Return MoveFigure(figure, current, info, key)
                ElseIf (TypeOf (figure) Is IFigureHandling) Then
                    Dim status As Boolean = DirectCast(figure, IFigureHandling).ModifyFigure(current, info, key)
                    If (Not status) Then
                        status = MoveFigure(figure, current, info, key)
                    End If
                    Return status
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiPoint) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiPoint), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiAnchor) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiAnchor), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiLine) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiLine), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiLineSegment) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiLineSegment), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiCircle) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiCircle), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiEllipse) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiEllipse), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiRectangle) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiRectangle), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiPolyline) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiPolyline), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiImage) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiImage), current, info, key)
                ElseIf (TypeOf (figure) Is FVIL.GDI.CFviGdiString) Then
                    Return ModifyFigure(DirectCast(figure, FVIL.GDI.CFviGdiString), current, info, key)
                Else
                    'm̐}`͈ړ̂.
                    Return MoveFigure(figure, current, info, key)
                End If
            End If

        End Function

        ''' <summary>
        ''' }`̉] (ėp)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function RotateFigure(ByVal figure As FVIL.GDI.CFviGdiFigure, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            Dim st As FVIL.Data.CFviAngle = Math.Angle(info.mouse, Math.Addition(figure.Position, figure.Axis))
            Dim ed As FVIL.Data.CFviAngle = Math.Angle(current, Math.Addition(figure.Position, figure.Axis))

            '{^̈ړʂvZ.
            Dim move As FVIL.Data.CFviAngle = Math.Subtraction(ed, st)

            '}`].
            figure.Angle = Math.Addition(info.angle, move)

            Return True
        End Function

        ''' <summary>
        ''' }`̈ړ (ėp)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function MoveFigure(ByVal figure As FVIL.GDI.CFviGdiFigure, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If
            If (Not EnableMove) Then
                Return False
            End If

            '{^̈ړʂvZ.
            Dim move As FVIL.Data.CFviPoint = Math.Subtraction(current, info.mouse)

            '}`ړ.
            figure.Position = Math.Addition(info.position, move)

            Return True
        End Function

        '}`̕ό`.

        ''' <summary>
        ''' }`̕ό` (_)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiPoint, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.

            If (info.iGripPosition <> 0) Then
                Return MoveFigure(figure, current, info, key)
            End If

            Return False
        End Function

        ''' <summary>
        ''' }`̕ό` (AJ[)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiAnchor, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            If (info.iGripPosition <> 0) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.
            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            If (info.iGripPosition = 1) Then    'n_.
                figure.St = pos
            ElseIf (info.iGripPosition = 1) Then    'I_.
                figure.Ed = pos
            End If

            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` ()
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiLine, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            If (info.iGripPosition < 0) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.
            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            '̎n_ƏI_ GetClipRect 擾ł܂AXlKv܂.
            Dim ls As FVIL.Data.CFviLineSegment = New FVIL.Data.CFviLineSegment(info.clip.St, info.clip.Ed)
            If (info.position <> info.clip.St) Then    'n_łȂ.
                ls.SX = info.clip.St.X
                ls.SY = info.clip.Ed.Y
                ls.EX = info.clip.Ed.X
                ls.EY = info.clip.St.Y
            End If

            '}`̕ό`.
            If (info.iGripPosition = 1) Then        'n_.
                ls.St = pos
                figure.CopyFrom(ls.ToCFviLine())
            ElseIf (info.iGripPosition = 2) Then    'I_.
                ls.Ed = pos
                figure.CopyFrom(ls.ToCFviLine())
            End If

            '--- @̕␳.
            ' Size ɂĎn_ƏI_ύX邽߁A@̕␳͂ł܂.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` ()
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiLineSegment, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            If (info.iGripPosition < 0) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.
            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            '}`̕ό`.
            If (info.iGripPosition = 1) Then        'n_.
                figure.St = pos
            ElseIf (info.iGripPosition = 2) Then    'I_.
                figure.Ed = pos
            End If

            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` (^~)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiCircle, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            Dim rectpos As FVIL.GDI.RectPosition = DirectCast(info.iGripPosition, FVIL.GDI.RectPosition)
            If ((rectpos And FVIL.GDI.RectPosition.ALL) = FVIL.GDI.RectPosition.ALL) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.
            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim mouse As FVIL.Data.CFviPoint = FVIL.Math.Rotate(info.mouse, axis, angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)
            Dim move As FVIL.Data.CFviPoint = Math.Subtraction(pos, mouse)

            '}`̕ό`.
            Dim L As Boolean = ((rectpos And FVIL.GDI.RectPosition.Left) = FVIL.GDI.RectPosition.Left)
            Dim R As Boolean = ((rectpos And FVIL.GDI.RectPosition.Right) = FVIL.GDI.RectPosition.Right)
            Dim T As Boolean = ((rectpos And FVIL.GDI.RectPosition.Top) = FVIL.GDI.RectPosition.Top)
            Dim B As Boolean = ((rectpos And FVIL.GDI.RectPosition.Bottom) = FVIL.GDI.RectPosition.Bottom)

            Dim clip As FVIL.Data.CFviRectangle = figure.GetClipRect()

            If (L And T) Then
                clip.Left = (mouse.X + move.X)
                clip.Top = (mouse.Y + move.X)
            ElseIf (L And B) Then
                clip.Left = (mouse.X + move.X)
                clip.Bottom = (mouse.Y - move.X)
            ElseIf (R And T) Then
                clip.Right = (mouse.X + move.X)
                clip.Top = (mouse.Y - move.X)
            ElseIf (R And B) Then
                clip.Right = (mouse.X + move.X)
                clip.Bottom = (mouse.Y + move.X)
            ElseIf (L) Then
                clip.Left = (mouse.X + move.X)
                clip.Top += move.X / 2
                clip.Bottom -= move.X / 2
            ElseIf (R) Then
                clip.Right = (mouse.X + move.X)
                clip.Top -= move.X / 2
                clip.Bottom += move.X / 2
            ElseIf (T) Then
                clip.Top = (mouse.Y + move.Y)
                clip.Left += move.Y / 2
                clip.Right -= move.Y / 2
            ElseIf (B) Then
                clip.Bottom = (mouse.Y + move.Y)
                clip.Left -= move.Y / 2
                clip.Right += move.Y / 2
            End If

            Dim radius_x As Double = clip.Width / 2
            Dim radius_y As Double = clip.Height / 2

            figure.X = clip.X + radius_x
            figure.Y = clip.Y + radius_y

            If (L Or R) Then
                figure.Radius = clip.Width / 2
            Else
                figure.Radius = clip.Height / 2
            End If


            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` (ȉ~)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiEllipse, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            Dim rectpos As FVIL.GDI.RectPosition = DirectCast(info.iGripPosition, FVIL.GDI.RectPosition)
            If ((rectpos And FVIL.GDI.RectPosition.ALL) = FVIL.GDI.RectPosition.ALL) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.
            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            '}`̕ό`.
            Dim clip As FVIL.Data.CFviRectangle = figure.GetClipRect()

            If ((rectpos And FVIL.GDI.RectPosition.Left) = FVIL.GDI.RectPosition.Left) Then
                clip.Left = pos.X
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Right) = FVIL.GDI.RectPosition.Right) Then
                clip.Right = pos.X
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Top) = FVIL.GDI.RectPosition.Top) Then
                clip.Top = pos.Y
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Bottom) = FVIL.GDI.RectPosition.Bottom) Then
                clip.Bottom = pos.Y
            End If

            Dim radius_x As Double = clip.Width / 2
            Dim radius_y As Double = clip.Height / 2

            figure.X = clip.X + radius_x
            figure.Y = clip.Y + radius_y
            figure.AxisX = radius_x
            figure.AxisY = radius_y

            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` (`)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiRectangle, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            Dim rectpos As FVIL.GDI.RectPosition = DirectCast(info.iGripPosition, FVIL.GDI.RectPosition)
            If ((rectpos And FVIL.GDI.RectPosition.ALL) = FVIL.GDI.RectPosition.ALL) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.
            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            '}`̕ό`.
            Dim clip As FVIL.Data.CFviRectangle = figure.GetClipRect()

            If ((rectpos And FVIL.GDI.RectPosition.Left) = FVIL.GDI.RectPosition.Left) Then
                clip.Left = pos.X
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Right) = FVIL.GDI.RectPosition.Right) Then
                clip.Right = pos.X
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Top) = FVIL.GDI.RectPosition.Top) Then
                clip.Top = pos.Y
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Bottom) = FVIL.GDI.RectPosition.Bottom) Then
                clip.Bottom = pos.Y
            End If

            figure.Left = clip.Left
            figure.Right = clip.Right
            figure.Top = clip.Top
            figure.Bottom = clip.Bottom

            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` (p`)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiPolyline, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            If (figure.Close) Then
                If (info.iGripPosition < 0) Then
                    '}`Ŝړ.
                    Return MoveFigure(figure, current, info, key)
                ElseIf ((0 < info.iGripPosition) And (info.iGripPosition <= figure.Count)) Then
                    '}`̕ό`.
                    '_ړāA}`ό`.
                    figure.Close = False
                    ModifyFigure(figure, current, info, key)
                    figure.Close = True

                    Return True
                End If
            Else
                '}EX̏ōWvZ.
                Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
                Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
                Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

                If (info.iGripPosition < 0) Then
                    '}`Ŝړ.
                    Return MoveFigure(figure, current, info, key)
                ElseIf ((0 < info.iGripPosition) And (info.iGripPosition <= figure.Count)) Then
                    '}`̕ό`.
                    '_ړāA}`ό`.
                    Dim index As Integer = info.iGripPosition - 1
                    figure(index) = pos

                    '--- @̕␳.
                    If (angle.Degree <> 0.0) Then
                        figure.Axis = Math.Subtraction(axis, figure.Position)
                    End If

                    Return True
                End If
            End If

            Return False
        End Function

        ''' <summary>
        ''' }`̕ό` (摜)
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiImage, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            Dim rectpos As FVIL.GDI.RectPosition = DirectCast(info.iGripPosition, FVIL.GDI.RectPosition)
            If ((rectpos And FVIL.GDI.RectPosition.ALL) = FVIL.GDI.RectPosition.ALL) Then
                Return MoveFigure(figure, current, info, key)
            End If

            '}`̕ό`.

            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            '}`̕ό`.
            Dim clip As FVIL.Data.CFviRectangle = figure.GetClipRect()

            If ((rectpos And FVIL.GDI.RectPosition.Left) = FVIL.GDI.RectPosition.Left) Then
                clip.Left = pos.X
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Right) = FVIL.GDI.RectPosition.Right) Then
                clip.Right = pos.X
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Top) = FVIL.GDI.RectPosition.Top) Then
                clip.Top = pos.Y
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Bottom) = FVIL.GDI.RectPosition.Bottom) Then
                clip.Bottom = pos.Y
            End If

            If (Not (clip.Left <= clip.Right)) Then
                Dim tmp As Double = clip.Left
                clip.Left = clip.Right
                clip.Right = tmp
            End If
            If (Not (clip.Top <= clip.Bottom)) Then
                Dim tmp As Double = clip.Top
                clip.Top = clip.Bottom
                clip.Bottom = tmp
            End If

            figure.Position = New FVIL.Data.CFviPoint(clip.Left, clip.Top)
            Dim stretchH As Integer = FVIL.Math.Round(clip.Width)
            Dim stretchV As Integer = FVIL.Math.Round(clip.Height)
            figure.StretchHorzSize = IIf(stretchH <= 0, 1, stretchH)
            figure.StretchVertSize = IIf(stretchV <= 0, 1, stretchV)

            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

        ''' <summary>
        ''' }`̕ό` ()
        ''' </summary>
        ''' <param name="figure">}`</param>
        ''' <param name="current">݂̃}EXʒu</param>
        ''' <param name="info">{^̏</param>
        ''' <param name="key">{^̃L[{[h</param>
        ''' <returns>
        '''   }`̑삪sꂽꍇ true Ԃ܂B
        '''   sȂꍇ false Ԃ܂B
        ''' </returns>
        Public Function ModifyFigure(ByVal figure As FVIL.GDI.CFviGdiString, ByVal current As FVIL.Data.CFviPoint, ByVal info As MouseInfo, ByVal key As KeyboardInfo) As Boolean
            If (info.iGripPosition = 0) Then
                Return False
            End If

            '}`ړ.
            Dim rectpos As FVIL.GDI.RectPosition = DirectCast(info.iGripPosition, FVIL.GDI.RectPosition)
            If ((rectpos And FVIL.GDI.RectPosition.ALL) = FVIL.GDI.RectPosition.ALL) Then
                Return MoveFigure(figure, current, info, key)
            ElseIf ((rectpos And FVIL.GDI.RectPosition.Top) <> FVIL.GDI.RectPosition.Top And (rectpos And FVIL.GDI.RectPosition.Bottom) <> FVIL.GDI.RectPosition.Bottom) Then
                If ((rectpos And FVIL.GDI.RectPosition.Left) = FVIL.GDI.RectPosition.Left Or (rectpos And FVIL.GDI.RectPosition.Right) = FVIL.GDI.RectPosition.Right) Then
                    Return MoveFigure(figure, current, info, key)
                End If
            End If

            '}`̕ό`.

            '}EX̏ōWvZ.
            Dim axis As FVIL.Data.CFviPoint = Math.Addition(info.position, info.axis)
            Dim angle As FVIL.Data.CFviAngle = Math.Invert(info.angle)
            Dim pos As FVIL.Data.CFviPoint = FVIL.Math.Rotate(current, axis, angle)

            '}`̕ό`.
            Dim clip As FVIL.Data.CFviRectangle = figure.GetClipRect()

            Dim alignV As FVIL.GDI.TextAlign = FVIL.GDI.TextAlign.Top
            If ((figure.Align And FVIL.GDI.TextAlign.Bottom) = FVIL.GDI.TextAlign.Bottom) Then
                alignV = FVIL.GDI.TextAlign.Bottom
            End If

            If ((rectpos And FVIL.GDI.RectPosition.Top) = FVIL.GDI.RectPosition.Top) Then
                If (alignV = FVIL.GDI.TextAlign.Top) Then
                    Return MoveFigure(figure, current, info, key)
                End If
                clip.Top = pos.Y
            End If
            If ((rectpos And FVIL.GDI.RectPosition.Bottom) = FVIL.GDI.RectPosition.Bottom) Then
                If (alignV = FVIL.GDI.TextAlign.Bottom) Then
                    Return MoveFigure(figure, current, info, key)
                End If
                clip.Bottom = pos.Y
            End If

            If (Not (clip.Left <= clip.Right)) Then
                Dim tmp As Double = clip.Left
                clip.Left = clip.Right
                clip.Right = tmp
            End If
            If (Not (clip.Top <= clip.Bottom)) Then
                Dim tmp As Double = clip.Top
                clip.Top = clip.Bottom
                clip.Bottom = tmp
            End If

            '--- tHg̍̂ݒ.( 0 (ɍœKȒl)Ƃ)
            Dim fontV As Integer = FVIL.Math.Round(clip.Height)
            fontV = IIf(fontV <= 9, 9, fontV)
            figure.Font.Size = New Size(0, fontV)

            '--- @̕␳.
            If (angle.Degree <> 0.0) Then
                figure.Axis = Math.Subtraction(axis, figure.Position)
            End If

            Return True
        End Function

    End Class

End Namespace